97 Commits

Author SHA1 Message Date
v4n 093d849c19 Updated README.md 2025-12-13 14:14:43 +02:00
v4n c98e0094ce Updated README.md 2025-12-13 14:14:09 +02:00
v4n 2ffc669010 fix: whitespace 2025-09-29 21:24:20 +03:00
v4n 9bfa8923fe chore: deprecate 2025-09-29 21:19:38 +03:00
v4n 87ec07b10a docs: improve (#95)
* docs: rewrite help commands

* docs: rewrite README.md

* docs: remove you language

* refactor: started parse refactor
2025-09-29 21:18:54 +03:00
v4n 687bdf6709 fix: modpack command works 2025-09-29 09:32:45 +03:00
v4n 3bf4a5e542 fix: modpack commands are separate (#93) 2025-09-21 07:20:58 +03:00
v4n c72ceb899e fix: nexus downloaded file http encoding 2025-09-16 22:49:21 +03:00
v4n 7c9544f419 fix: pick variant wrong labels 2025-09-16 17:10:50 +03:00
v4n 9627ee199f fix: pick variant wrong labels 2025-09-16 15:39:28 +03:00
v4n 53d9f8a093 fix: pick variant wrong labels 2025-09-16 15:35:54 +03:00
v4n 96163fc7d9 fix: remove SteamOS prompt in favor of automatic detection (#87) 2025-09-16 15:05:08 +03:00
v4n 84cbc80eb2 fix: pick variant empty folder 2025-09-16 14:53:31 +03:00
v4n 423ea1280d fix: pick variant exclusion 2025-09-16 14:45:06 +03:00
v4n 05548ca460 docs: add changelogs link 2025-09-16 14:17:55 +03:00
v4n 30649e0312 feat: enhance variant picker (#86)
* fix: variant display is more clear

* fix: unable to install all variants

* feat: select variants with ranges and exclusions
2025-09-16 14:13:51 +03:00
v4n c3d76c625c fix: help command stops displaying an error (#84) 2025-08-28 20:40:47 +03:00
v4n a9a17a7617 fix: /tmp no longer clogged by random leftover mods (#82) 2025-08-28 20:35:23 +03:00
v4n 711d416e49 fix: order command changing indexes wrong (#79) 2025-08-01 16:17:20 +03:00
v4n a9e11211f4 fix: wrong mod name when using Nexus integration 2025-07-21 15:52:13 +03:00
v4n 1d35ac00d7 fix: remove nexus-update from help (#75)
* fix: remove nexus-update from help

* bump: version
2025-07-18 15:31:23 +03:00
v4n 5b10fbf364 fix: error when updating on steam deck (#72) 2025-07-12 12:36:12 +03:00
v4n 1f2a34dc5b fix: additional help 2025-07-09 20:50:57 +03:00
v4n 159dd47851 fix: help messages/docs 2025-07-09 20:39:32 +03:00
v4n 73cd330ab0 fix: docs 2025-06-30 22:31:51 +03:00
v4n 2efed53b4c fix: enable command no longer changes order (#70) 2025-06-30 13:17:31 +03:00
v4n b501f642c9 fix: no sudo if path writable (#68) 2025-06-28 16:43:29 +03:00
v4n 28684be2de fix: disable command reaching file char limit (#66) 2025-06-23 09:44:20 +03:00
v4n 397b50bc19 code: database headers are universal 2025-06-21 12:41:09 +03:00
v4n 61a15ef816 fix: order command works again 2025-06-21 11:55:49 +03:00
v4n d435bb35ac fix: color 2025-06-21 11:47:18 +03:00
v4n a75d92252e fix: list verbose mode not crashing 2025-06-21 11:46:11 +03:00
v4n 2c51e2bfd3 fix: version number url 2025-06-20 15:18:18 +03:00
v4n 1c1235c85e fix: remove nexus upgrade delay (#63) 2025-06-20 15:07:11 +03:00
v4n 7cedfcb451 feat: added rename command (#62) 2025-06-20 11:10:41 +03:00
v4n 0fdc5a2306 fix: nexus integration does not quit prematurely 2025-05-17 14:23:44 +03:00
v4n 13dc822fd9 fix: nexus integration on Steam Deck (#55) 2025-05-16 16:59:14 +03:00
F. St. 35302aa7c7 fix: print parent folder of mod variants (#52)
* Print parent folder of mod variants

Because some mods have multiple variants with the same name.
As is, it is impossible to tell them apart in the selection.
This commit changes the selection to also print the parent folder of the
variants.

* remove the name of the mod zip/dir itself because it not necessary

---------

Co-authored-by: v4n <105587619+v4n00@users.noreply.github.com>
2025-04-19 14:57:20 +03:00
v4n ebadc049e7 fix: confirm after auto-finding HD2 path (#51) 2025-04-17 17:41:56 +03:00
v4n 649404c2d4 fix: sanitize file name of commas (fixes #48) (#49) 2025-04-16 14:54:59 +03:00
v4n 737fa01c11 feat: 7z file format support (#47) 2025-04-15 18:06:54 +03:00
v4n 0ac711085b fix: date invalid issue (fixes #46) 2025-04-15 17:56:06 +03:00
v4n 146b711a9b feat: nexus mods integration (#44)
* progress

* working download

* save details in db, display them

* progress

* progress

* progress

* progress

* i guess it's shippable

* final commit
2025-04-11 23:29:06 +03:00
v4n 5aafd2f16b fix: detailed instructions on installing in case of error 2025-04-03 00:24:02 +03:00
v4n c30d2a46a5 feat: modpack list verbose mode & improvements (#35) 2025-03-22 21:21:13 +02:00
v4n b6e92e2918 feat: install rar mods (#34) 2025-03-22 20:23:21 +02:00
v4n afbb6d3a0c fix: steam deck forgot to source bashrc 2025-03-22 19:46:07 +02:00
v4n f87b2709b0 bump: version 2025-03-20 11:54:20 +02:00
v4n 7666638328 feat: export can specify path (#33) 2025-03-20 11:53:52 +02:00
v4n 5f7f2a261a fix: mods db was deleted due to incorrect pipe 2025-03-19 23:24:34 +02:00
v4n efe8720507 fix: added temporary backup making in case mods get deleted 2025-03-19 23:01:18 +02:00
v4n cb71852068 fix: prompts for install script 2025-03-19 20:25:44 +02:00
v4n 26031c0381 version 0.4.0 release 2025-03-19 20:20:12 +02:00
Daedalusspacegames 9c73be1cb7 fix: modify date syntax to enhance compatibility with alternate coreutils implementations, such as [uutils](https://github.com/uutils/coreutils) (#29) 2025-03-19 12:10:17 +02:00
v4n a8e94c19fb feat: command to change load order of mods (#27)
* progress

* progress

* feat: progress

* progress

* done, needs more testing, pr -> change all functions to require -n before specifying name -> v0.4 (reindex db)

* testing done
2025-03-18 16:18:48 +02:00
v4n 6b968172ea fix: updating now works properly 2025-03-10 21:42:55 +02:00
v4n b3bc91522f do not update 2025-03-10 21:14:37 +02:00
v4n a7936c90bd fix: stop latest update 2025-03-10 21:07:03 +02:00
v4n 4d1af7e4a0 feat: modpack-create can select individual mods (#26) 2025-03-10 21:01:06 +02:00
v4n 0eff8afe6b fix: turned code into fn 2025-03-08 00:38:04 +02:00
v4n 3593e32a7b fix: upgrade mods was overwriting files 2025-03-07 23:24:30 +02:00
v4n 797739ea7a fix: uninstall correctly reindexes (fix #21) 2025-03-07 22:57:14 +02:00
v4n df006a7430 fix: infite loop while enabling (#25) 2025-03-07 18:20:34 +02:00
v4n 344e4348d4 fix: non important sed error 2025-03-06 04:09:45 +02:00
v4n 719217d00b bump: version 2025-03-06 01:29:45 +02:00
v4n b1930811f9 fix: segfault from infinite recursion 2025-03-06 01:29:14 +02:00
v4n d1ca18b563 bump: downgrade because of seg fault 2025-03-06 00:59:58 +02:00
v4n 5d91190dbf fix: code cleanup 2025-03-06 00:12:59 +02:00
v4n 28122ee332 feat: list is now compact, added verbose option 2025-03-05 19:09:57 +02:00
v4n 56bb73784e fix: directory checking in wrong place 2025-03-02 15:38:07 +02:00
v4n 0d8f22a2d0 fix: variants fix 2025-02-21 17:15:35 +02:00
v4n 3c6238f8d2 fix: show variants better 2025-02-21 16:16:42 +02:00
v4n a031230117 fix: bash black magic 2025-02-21 16:06:20 +02:00
v4n 77ae53ffa7 fix: weird update bug 2025-02-21 14:03:49 +02:00
v4n c23c57e16c fix: weird update bug 2025-02-21 14:01:36 +02:00
v4n 898400e526 fix: whitespace in help msg 2025-02-21 13:48:50 +02:00
v4n c45f5860d8 bump: version 2025-02-21 13:44:18 +02:00
v4n 838c834cc2 feat: easily install multiple variants (#20)
* feat: easily install multiple variants

* fix: filter only dirs that have patches
2025-02-21 13:16:29 +02:00
v4n 7b8b2fda8f fix: console output, formatting 2025-02-21 12:46:46 +02:00
Catherine Guelque 0485b56df5 There is no need to install in the global path nor to use SUDO if the given path was writtable (#18)
* There's no need for sudo + Added warning if not in PATH

* fix: removed duplicated command call

---------

Co-authored-by: v4n <105587619+v4n00@users.noreply.github.com>
2025-02-17 18:07:54 +02:00
v4n d18a9cdccf fix: formatting 2025-02-06 20:13:45 +02:00
v4n c74f4a8a00 fix: whitespace, version bump for earlier commit 2025-02-06 20:12:27 +02:00
Matt Cavanagh 9f592e7ce2 feat: added .editorconfig to ensure consistency across IDEs and to prevent line ending oopsies (#17) 2025-02-06 19:47:37 +02:00
v4n 21b1822006 fix: uninstall correctly downgrades 2025-02-06 19:43:30 +02:00
v4n dbcc7d1e96 fix: CRLF -> LF 2025-02-06 03:34:33 +02:00
v4n 09c40aa25f bump: version 2025-02-05 23:32:50 +02:00
Matt Cavanagh 1a01034816 feat: added self update mechanism (#15)
* feat: Added self update mechanism

* fix: Formatting

* fix: Formatting again

* fix: Arghhh INDENTATION

* feat: Updated readme with new command

* feat: Added shortcut command

* feat: Added more detail to the readme

* feat: Removed the check for the last update file. It seems a bit pointless to delay checking for it, it's curling github so it's not like it's a DDOS concern, and it could be the tool is getting updated often, why delay their updates? It's also just a curl, it's very inexpensive.

* feat: Removed REPO_URL, it was unused

* feat: Reverted version testing change (oops)

* feat: checking for updates timed at 1 hour

* fix: info messages formatting

---------

Co-authored-by: v4n <105587619+v4n00@users.noreply.github.com>
2025-02-05 23:29:21 +02:00
v4n 83e2161456 code: removed unnecessary parameter passing 2025-02-05 17:09:15 +02:00
Luca Saalfeld a2b904caa2 feat: prevent the same mod from being installed multiple times (#14)
* prevent the same mod from being installed multiple times

* use flag instead of variable for exit check
2025-02-05 16:59:00 +02:00
v4n 9f622ca130 bump: version 2025-02-05 16:27:04 +02:00
v4n 0ab273977e fix: function return typo, trailing slashes removed from paths (#13) 2025-02-05 16:23:32 +02:00
Luca Saalfeld 388afe69b7 fix: bash date comparison (#12) 2025-02-05 15:22:10 +02:00
v4n 3f0305c741 feat: steam deck install 2025-02-03 02:08:50 +02:00
v4n 1a6a13a621 fix: enable/disable logic 2025-02-03 01:49:41 +02:00
Harsh Shandilya 23cb0646bf Use portable shebangs (#7)
* h2mm: use portable shebang

* install.sh: use portable shebang
2025-01-28 11:49:51 +02:00
v4n 6768cab391 fix: disabling/enabling correctly downgrades/upgrades 2025-01-27 00:10:44 +02:00
v4n 35902f1f8f fix: downgrade logic 2025-01-23 09:29:48 +02:00
6 changed files with 2004 additions and 785 deletions
+6
View File
@@ -0,0 +1,6 @@
[*]
indent_style = tab
indent_size = 4
end_of_line = lf
insert_final_newline = true
trim_trailing_whitespace = true
+6 -5
View File
@@ -1,5 +1,6 @@
* *
!h2mm !h2mm
!install.sh !install.sh
!README.md !README.md
!version !version
!.editorconfig
+37 -124
View File
@@ -2,153 +2,66 @@
Helldivers 2 Mod Manager CLI is a command line interface for managing Helldivers 2 mods. Since there is no Linux mod manager available and I like being a nerd by using CLI tools instead of GUIs, this project was born. Helldivers 2 Mod Manager CLI is a command line interface for managing Helldivers 2 mods. Since there is no Linux mod manager available and I like being a nerd by using CLI tools instead of GUIs, this project was born.
This script is complete, the version will always [remain at 0.x.x](https://0ver.org/) ## Installation
## Installation and updating Pre-requisites:
To install/update Helldivers 2 Mod Manager CLI run the following command in your terminal: - The `unzip` package must be installed for ZIP archives.
- The `unarchiver` package is recommended for RAR and 7Z archives.
To install Helldivers 2 Mod Manager CLI run the following command in the terminal:
```bash ```bash
bash -c "$(curl -fsSL https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh)" bash -c "$(curl -fsSL https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh)"
``` ```
> [!CAUTION]
> Running this script will require sudo permissions. **DO NOT TRUST** random scripts from the internet. If you want to review the script before running it, check out the mod repository for yourself.
If for some reason, the installation command doesn't work you can:
1. Go to https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh
1. Right click -> Save page as...
1. Go to your downloads folders `cd ~/Downloads`
1. Give the script execution permissions `chmod +x install.sh`
1. Run the script `./install.sh`
## Usage ## Usage
The script gets added to `/usr/local/bin/h2mm` and can be used by running `h2mm` in your shell, which will show the help message explaining how to use the script. The script gets added to `/usr/local/bin/h2mm` (or `$HOME/.local/bin` on Steam Deck) and can be used by running `h2mm` in the shell, which will print the help message along with all available commands.
```bash ```bash
h2mm h2mm --help
``` ```
### Available commands To find out how to use a command, run `h2mm COMMAND --help`. This is the most up-to-date source of information about the commands.
- `install` - Install a mod by the file provided (directory, zip, patch). ## Available commands
- `uninstall` - Uninstall a mod by name (or index).
- `list` - List all installed mods.
- `enable` - Enable a mod by name (or index).
- `disable` - Disable a mod by name (or index).
- `export` - Export installed mods to a zip file.
- `import` - Import mods from a zip file.
- `modpack-create` - Create a modpack from the currently installed mods.
- `modpack-switch` - Switch to a modpack by name (or index).
- `modpack-list` - List all installed modpacks.
- `modpack-delete` - Delete a modpack by name (or index).
- `modpack-overwrite` - Overwrite a modpack by name (or index).
- `modpack-reset` - Reset all installed modpacks.
- `reset` - Reset all installed mods.
- `help` - Display this help message.
### Basic usage - `install` or `i` - Install a mod by the file provided (directory, zip, patch)
- `uninstall` or `u` - Uninstall a mod
- `list` or `l` - List all installed mods
- `enable` or `e` - Enable a mod
- `disable` or `d` - Disable a mod
- `rename` or `r` - Rename a mod
- `order` or `o` - Change load order for a mod
- `export` or `ex` - Export installed mods to a zip file
- `import` or `im` - Import mods from a zip file
- `modpack` or `m` - Manage modpacks (collections of mods)
- `nexus-setup` or `ns` - Setup Nexus Mods integration
- `update` or `up` - Update h2mm to latest version
- `reset` or `rs` - Reset all installed mods
- `help` or `h` - Display this help message
#### Install mod(s) ## Examples
```bash
h2mm install /path/to/mod.zip
h2mm install /path/to/mod/files
h2mm install /path/to/mod.zip /path/to/mod2.zip /path/to/mod/files
h2mm install -n "Example mod" mod.patch_0 mod.patch_0.stream # -n is mandatory when using files
h2mm install -n "Example mod" mod* # using a wildcard to include all files
```
> [!NOTE]
> If the mod has more than 1 variant, you need to install the one you want by unarchiving it separately and providing the directory.
#### Uninstall a mod
```bash
h2mm uninstall "Example mod"
h2mm uninstall -i 1 # uninstall mod with index 1
```
#### Enable/disable mods
```bash
h2mm enable "Example mod"
h2mm enable -i 1 # enable mod with index 1
h2mm disable "Example mod"
h2mm disable -i 1 # disable mod with index 1
```
#### List installed mods
```bash ```bash
h2mm install --help
h2mm install ~/Downloads/mod.zip
h2mm install ~/Downloads/mod\ files/
h2mm install a0b1c2d3.patch_0 a0b1c2d3.patch_0.stream -n "Example mod"
h2mm list h2mm list
h2mm uninstall --index 3
h2mm modpack create "Example modpack"
h2mm modpack switch "Example modpack"
``` ```
## Compatibility > When installing, it is recommended to be in the directory where mod archives are, or to use absolute paths. Use `cd ~/Downloads` to go to the Downloads folder, and run `ls -la` to find the archives to install. Use the Tab key to auto-complete file and folder names, this helps escape spaces and special characters.
>
> Use the `--index` flag with commands that normally require a mod name to specify a mod by its index. The index can be obtained with `h2mm list`.
The script is developed and tested on Arch Linux, but it should work on other Linux distributions as well. If you encounter any issues, please open an issue on the repository. ## Nexus Mods integration
Status of platforms: Nexus Mods integration allows the use the 1-click install feature of Nexus Mods (with the "Vortex" or "Mod manager download" buttons). Set up Nexus Mods integration by running `h2mm nexus-setup`. Setup includes providing the Nexus Mods API key and selecting the preferred terminal.
- Linux :white_check_mark:
- Steam Deck - untested (should work) :grey_question:
- Windows - WSL :white_check_mark:
> The script works on WSL, but you need to specify the path to the Helldivers 2 mods directory manually, to find your Windows partition head to `/mnt/` and from there go to your Helldivers 2 data directory, on a typical install it should be on `/mnt/c/Program\ Files\ \(x86\)/Steam/steamapps/common/Helldivers\ 2/data`. You also need to have `unzip` installed, which can be done by running `sudo apt install unzip`.
## Advanced usage
### Shortcuts
You can use the short form of commands to save some time. The shortcuts are:
- `i` for `install`
- `u` for `uninstall`
- `e` for `enable`
- `d` for `disable`
- `l` for `list`
- `ex` for `export`
- `im` for `import`
- `mc` for `modpack-create`
- `ms` for `modpack-switch`
- `ml` for `modpack-list`
- `md` for `modpack-delete`
- `mo` for `modpack-overwrite`
- `mr` for `modpack-reset`
- `r` for `reset`
### Modpacks support
You can set up modpacks by using the `modpack-*` commands. This allows you to quickly change between a set of mods. For more information, check the help message.
```bash
h2mm modpack-create "Modpack 1"
# install, enable, disable other mods...
h2mm modpack-create "Modpack 2"
h2mm modpack-switch "Modpack 1"
```
### Exporting and importing
You can export all installed mods to a zip file and import mods from the same file. This can be useful for sharing mods with others or for backing up your mods. The archive file (`.tar.gz`) will be saved in the current directory.
```bash
h2mm export modpack1.zip
h2mm import modpack2.zip
```
### Resetting all installed mods
You can reset all installed mods by running the following command. This will remove all installed mods and the database, in case things go wild.
```bash
h2mm reset
```
### Database location and details
The database is stored in the `Helldivers 2` install directory, under the `data` folder with the name `mods.csv`, where the mods are also installed. The database is a simple CSV file which you can use to manually manage mods if needed, you can mostly use it to rename or reorder mods.
## Contributing ## Contributing
+1782 -565
View File
File diff suppressed because it is too large Load Diff
+172 -90
View File
@@ -1,4 +1,4 @@
#!/bin/bash #!/usr/bin/env bash
set -e set -e
RED='\033[0;31m' RED='\033[0;31m'
@@ -7,123 +7,205 @@ ORANGE='\033[0;33m'
NC='\033[0m' NC='\033[0m'
DESTINATION_PATH="/usr/local/bin" DESTINATION_PATH="/usr/local/bin"
SCRIPT_NAME="h2mm"
REPO_URL="https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master" REPO_URL="https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master"
if [ "$(id -u)" -eq 0 ]; then function log() {
echo "Run me as normal user, not as root." local type="$1"
exit 1 shift
fi case "$type" in
INFO)
echo -e "$*" >&2
;;
ERROR)
echo -e "${RED}[ERROR]${NC} $*" >&2
;;
PROMPT)
echo -ne "$*" >&2
;;
esac
}
# --- Main --- # --- Main ---
# Warning log INFO "Running h2mm CLI Installer (https://github.com/v4n00/h2mm-cli)"
echo -e "!!! ${RED}WARNING${NC} !!!"
echo -e "This script will install Helldivers 2 Mod Manager CLI for Linux to $DESTINATION_PATH/$SCRIPT_NAME."
echo -e "Running this script will require sudo permissions. ${RED}DO NOT TRUST${NC} random scripts from the internet."
echo -e "If you want to review the script before running it, check out the mod repository for yourself:"
echo -e "https://github.com/v4n00/h2mm-cli"
echo -e "!!! ${RED}WARNING${NC} !!!"
echo
# Check if update
# Breaking changes hash table
# breaking changes hash table
breaking_changes_patches=( breaking_changes_patches=(
["2"]='sed -i "s/^\([0-9]\+\),/\1,ENABLED,/" "$1/mods.csv"' ["2"]='sed -i "s/^\([0-9]\+\),/\1,ENABLED,/" "$1/mods.csv"'
["3"]='sed -i "1 i\\3" "$1/mods.csv"' ["3"]='sed -i "1 i\\3" "$1/mods.csv"'
["4"]='tmp_file=$(mktemp) && awk '\''BEGIN {FS=OFS=","} NR==1 {print 4; next} {print NR-1, $2, $3, $4, $5}'\'' "$1/mods.csv" > "$tmp_file" && tee "$1/mods.csv" < "$tmp_file" > /dev/null && rm "$tmp_file"'
["5"]='sed -i "s/^\([0-9]\+\),\(.*\),\(.*\),\(.*\)/\1,\2,\3,,,,\4/" "$1/mods.csv"; sed -i "1 s/4/5/" "$1/mods.csv"'
["6"]='sed -i "s/^\([0-9]\+\),\(.*\),\(.*\),\(.*\),\(.*\),\(.*\),\(.*\)/\1,\2,\3,\4,\6,\7/" "$1/mods.csv"; sed -i "1 s/5/6/" "$1/mods.csv"'
) )
# Handle breaking changes # notify if update is happening
installed_version=""
latest_version=""
if [[ -x "$(command -v h2mm)" ]]; then
installed_version=$(h2mm --version)
if [[ -x "$(command -v $SCRIPT_NAME)" ]]; then # if installed version isn't x.x.x crash
installed_version=$($SCRIPT_NAME --version) if [[ ! "$installed_version" =~ ^[0-9]+\.[0-9]+\.[0-9]+$ ]]; then
# version 1 show the help message, if the first character is not a 0, store installed version as 0.1.6 log ERROR "Installed version is not in the correct format."
[[ ${installed_version:0:1} != "0" ]] && { installed_version="0.1.6"; } log ERROR "h2mm is installed here -> $(which h2mm)"
log ERROR "Delete the script file and retry the install script, any mods installed will not be lost."
log INFO 'Download using the command: bash -c "$(curl -fsSL https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh)"'
exit 1
fi
latest_version=$(curl -sS "$REPO_URL"/version) latest_version=$(curl -sS "$REPO_URL"/version)
if [[ "$latest_version" == "$installed_version" ]]; then if [[ "$latest_version" == "$installed_version" ]]; then
echo -e "You are reinstalling version $installed_version." log INFO "You are reinstalling version ${GREEN}$installed_version${NC}."
else else
echo -e "You are upgrading from ${ORANGE}$installed_version${NC} -> ${GREEN}$latest_version${NC}." log INFO "You are upgrading from ${ORANGE}$installed_version${NC} -> ${GREEN}$latest_version${NC}."
fi fi
fi
# split version numbers # if steam os, set destination path to ~/.local/bin
installed_major="" steamos=false
latest_major=""
IFS='.' read -r _1 installed_major _2 <<< "$installed_version"
IFS='.' read -r _1 latest_major _2 <<< "$latest_version"
if [[ $latest_major -gt $installed_major ]]; then if [[ -f "/etc/os-release" ]]; then
echo -e "${ORANGE}Warning:${NC} Major version upgrade detected." if grep -q "ID=steamos" /etc/os-release; then
echo "Check out the changelogs here:" steamos=true
echo "https://github.com/v4n00/h2mm-cli/releases" fi
echo "The script will proceed to upgrade ${SCRIPT_NAME} to avoid breaking changes." fi
# find hd2 path if [[ $steamos == true ]]; then
search_dir="${HOME}" # steam os
target_dir="Steam/steamapps/common/Helldivers\ 2/data" DESTINATION_PATH="$HOME/.local/bin"
echo "Searching for the Helldivers 2 data directory... (20 seconds timeout)" >&2 log INFO "Detected SteamOS, setting installation path to ${ORANGE}$DESTINATION_PATH${NC}."
game_dir=$(timeout 20 find "$search_dir" -type d -path "*/$target_dir" 2>/dev/null | head -n 1) mkdir -p "$DESTINATION_PATH"
if [[ -z "$game_dir" ]]; then
echo "Could not find the Helldivers 2 data directory automatically." >&2 # check if ~/.local/bin is in PATH
IFS= read -ep "Please enter the path to the Helldivers 2 data directory: " game_dir if [[ ":$PATH:" != *":$HOME/.local/bin:"* ]]; then
if [[ ! -d "$game_dir" ]]; then # add ~/.local/bin to PATH
echo -e "${RED}Error${NC}: Provided path is not a valid directory." >&2 log INFO "Installing the script on SteamOS means adding ${ORANGE}$DESTINATION_PATH${NC} to your \$PATH."
exit 1 log INFO "If you're using a different shell than bash (the default), you may need to add it manually."
fi
log PROMPT "Do you want to automatically add ${ORANGE}$DESTINATION_PATH${NC} to your \$PATH in ~/.bashrc? (Y/n): "
IFS= read -e response
if [[ "$response" == "y" || "$response" = "Y" || -z "$response" ]]; then
echo "export PATH=\"\$HOME/.local/bin:\$PATH\"" >> "$HOME/.bashrc"
[[ $? -ne 0 ]] && { log ERROR "Failed to add $DESTINATION_PATH to \$PATH in ~/.bashrc." ; exit 1; }
source "$HOME/.bashrc"
export PATH="$HOME/.local/bin:$PATH" # fallback kinda in case sourcing fails
log INFO "Added ${ORANGE}$DESTINATION_PATH${NC} to your \$PATH in ~/.bashrc."
fi
fi
else
# not steam os
# set another path if needed
log PROMPT "Install the script to ${ORANGE}$DESTINATION_PATH${NC} or specify another path (must be included in \$PATH)? (Y/path): "
IFS= read -e response
if [[ "$response" != "y" && "$response" != "Y" && -n "$response" ]]; then
DESTINATION_PATH="$response"
[[ ! -d "$DESTINATION_PATH" ]] && { log ERROR "Path $DESTINATION_PATH does not exist." ; exit 1; }
fi
fi
# handle breaking changes
installed_major=$(echo "$installed_version" | awk -F. '{print $2}')
latest_major=$(echo "$latest_version" | awk -F. '{print $2}')
if [[ $latest_major -gt $installed_major ]]; then
log INFO ""
log INFO "${GREEN}IMPORTANT${NC}: Major version upgrade detected. Check out the changelogs here -> https://github.com/v4n00/h2mm-cli/releases"
log INFO "The script will proceed to upgrade the database file. Creating a backup in case anything goes wrong."
# make backup
h2mm export
# check if game directory is in ~/.config/h2mm/h2path
if [[ -f "$HOME/.config/h2mm/h2path" ]]; then
game_dir=$(cat "$HOME/.config/h2mm/h2path")
[[ ! -d "$game_dir" ]] && { log ERROR "Helldivers 2 data directory is not valid: $game_dir." ; exit 1; }
else
log INFO "Searching for the Helldivers 2 data directory... (10 seconds timeout)"
game_dir=$(timeout 10 find "$HOME" -type d -path "*/Steam/steamapps/common/Helldivers\ 2/data" 2>/dev/null | head -n 1)
fi
# if not found, prompt user
if [[ -z "$game_dir" ]]; then
# if not found, ask user for the directory
log INFO "Could not find the Helldivers 2 data directory automatically."
log PROMPT "Please enter the path to the Helldivers 2 data directory: "
IFS= read -e game_dir; unset IFS
game_dir="$(substitute_home "$game_dir")"
[[ ! -d "$game_dir" ]] && { log ERROR "Provided path is not a valid directory."; exit 1; }
else
# confirm with the user that the directory is ok
log INFO "Found Helldivers 2 data directory: $game_dir"
log PROMPT "Is this the correct directory? (Y/n): "
read confirm
if [[ "$confirm" != "y" && "$confirm" != "Y" && "$confirm" != "" ]]; then
log PROMPT "Please enter the path to the Helldivers 2 data directory: "
IFS= read -e game_dir; unset IFS
game_dir="$(substitute_home "$game_dir")"
[[ ! -d "$game_dir" ]] && { log ERROR "Provided path is not a valid directory."; exit 1; }
fi
fi
[[ ! -f "$game_dir/mods.csv" ]] && { log ERROR "mods.csv not found in $game_dir." ; exit 1; }
# iterate from installed major number to latest major number
for ((i = installed_major + 1; i <= latest_major; i++)); do
if [[ -n "${breaking_changes_patches[$i]}" ]]; then
# apply breaking changes patch
eval $(echo "${breaking_changes_patches[$i]}" | sed "s:\$1:$game_dir:g")
else
log INFO "No breaking changes for version $i."
continue
fi fi
[[ ! -f "$game_dir/mods.csv" ]] && { echo -e "${RED}Error:${NC} mods.csv not found in $game_dir."; exit 1; } if [[ $? -ne 0 ]]; then
log ERROR "Failed to apply breaking changes patch for version $i. Do you want to continue? (Y/n): "
# make backup of mods in case something goes wrong read -er response
echo "Creating a backup of mods.csv."
h2mm export
# iterate from installed major number to latest major number [[ "$response" != "y" && "$response" != "Y" && -n "$response" ]] && { log INFO "Exiting." ; exit 1; }
for ((i = installed_major + 1; i <= latest_major; i++)); do else
echo -e "Applying breaking changes patch for version $i." log INFO "Version upgrade fix ${GREEN}successfully${NC} applied for version $i."
fi
if [[ -n "${breaking_changes_patches[$i]}" ]]; then done
eval $(echo "${breaking_changes_patches[$i]}" | sed "s:\$1:$game_dir:") log INFO ""
else
echo "No breaking changes for version $i."
fi
if [[ $? -ne 0 ]]; then
echo -ne "${RED}Error:${NC} Failed to apply breaking changes patch for version $i. Do you want to continue? (Y/n): "
read -er response
[[ "$response" != "y" && "$response" != "Y" && -n "$response" ]] && { echo "Exiting. Uninstall the script first the retry the install script."; exit 1; }
else
echo -e "Breaking changes patch for version ${ORANGE}$i${NC} applied ${GREEN}successfully${NC}."
fi
done
fi
echo
fi fi
# Install # install
log INFO "Installing h2mm to ${ORANGE}$DESTINATION_PATH${NC}."
IFS= read -ep "Install the script to $DESTINATION_PATH or specify another path (must be included in \$PATH)? (Y/path): " response # check if we need sudo based on destination path
SUDO_CMD=""
if [[ "$response" != "y" && "$response" != "Y" && -n "$response" ]]; then if [[ ! -w "$DESTINATION_PATH" || ( -f "$DESTINATION_PATH/h2mm" && ! -w "$DESTINATION_PATH/h2mm" ) ]]; then
DESTINATION_PATH="$response" SUDO_CMD="sudo"
if [[ ! -d "$DESTINATION_PATH" ]]; then log INFO "Destination path ${RED}requires${NC} elevated permissions, using sudo."
echo -e "${RED}Error:${NC} Path $DESTINATION_PATH does not exist."
exit 1
fi
fi fi
echo "Installing $SCRIPT_NAME to $DESTINATION_PATH." $SUDO_CMD curl "$REPO_URL"/h2mm --output "$DESTINATION_PATH/h2mm"
sudo curl "$REPO_URL"/h2mm --output "$DESTINATION_PATH/$SCRIPT_NAME" $SUDO_CMD chmod +x "$DESTINATION_PATH/h2mm"
sudo chmod +x "$DESTINATION_PATH/$SCRIPT_NAME" log INFO ""
if [[ ! -x "$(command -v $SCRIPT_NAME)" ]]; then [[ ! -x "$(command -v h2mm)" ]] && { log ERROR "Installation failed. Mod manager was not found in \$PATH." ; exit 1; }
echo -e "${RED}Error:${NC} Installation failed."
exit 1
fi
echo "Helldivers 2 Mod Manager CLI installed successfully to $DESTINATION_PATH/$SCRIPT_NAME. Use it by running '$SCRIPT_NAME'." log INFO "Helldivers 2 Mod Manager CLI ${GREEN}successfully${NC} installed."
log INFO "${GREEN}IMPORTANT${NC}: To install mods, you need to have installed:"
log INFO " -> \"unzip\" package for .zip archives"
log INFO " -> \"unarchiver\" package for .rar archives"
log INFO "If you do not know how to install these packages, please search for your linux distro on how to install packages."
log INFO ""
log INFO "Use the mod manager by running 'h2mm' in your terminal."
log INFO "View the changelogs: https://github.com/v4n00/h2mm-cli/releases/latest"
log INFO "Check out the ${ORANGE}Nexus Mods integration${NC} by running 'h2mm nexus-setup'."
log INFO "Made with <3 by v4n and contributors."
log INFO ""
log INFO "${RED}Special announcement:${NC}"
log INFO "The Helldivers 2 Mod Manager CLI is now deprecated in favor of the Arsenal Mod Manager."
log INFO "Check it out here: https://www.nexusmods.com/helldivers2/mods/4664"
log INFO "The Arsenal Mod Manager has a GUI and is more user friendly,"
log INFO "making it the preferred choice for most users, especially since it now works on Linux!"
log INFO "Thank you for using the Helldivers 2 Mod Manager CLI, and we hope to see you on the Arsenal Mod Manager!"
+1 -1
View File
@@ -1 +1 @@
0.3.0 0.7.0